=== debian/changelog ===
gammaray (2.11.1-0ubuntu1) groovy; urgency=medium

  * New upstream bugfix release.
  * Build-depend on qml-module-qtqml.
  * Install the 3dinspector plugins.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 17 May 2020 17:27:25 +0300
